Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -3542,136 +3756,131 @@
 !
 !-- Aero-aero coagulation
-    DO  mm = 1, fn2b   ! smaller colliding particle
+    DO  mm = 1, end_subrange_2b   ! smaller colliding particle
        IF ( paero(mm)%numc < nclim )  CYCLE
-       DO  nn = mm, fn2b   ! larger colliding particle
+       DO  nn = mm, end_subrange_2b   ! larger colliding particle
           IF ( paero(nn)%numc < nclim )  CYCLE
-          
+
           zdpart_mm = MIN( paero(mm)%dwet, 30.0E-6_wp )     ! Limit to 30 um
           zdpart_nn = MIN( paero(nn)%dwet, 30.0E-6_wp )     ! Limit to 30 um
-!             
+!
 !--       Coagulation coefficient of particles (m3/s)
-          zcc(mm,nn) = coagc( zdpart_mm, zdpart_nn, zmpart(mm), zmpart(nn),    &
-                              temppi, pressi )
+          zcc(mm,nn) = coagc( zdpart_mm, zdpart_nn, zmpart(mm), zmpart(nn), temppi, pressi )
           zcc(nn,mm) = zcc(mm,nn)
        ENDDO
     ENDDO
-       
-!    
+
+!
 !-- 3) New particle and volume concentrations after coagulation:
 !--    Calculated according to Jacobson (2005) eq. 15.9
 !
 !-- Aerosols in subrange 1a:
-    DO  b = in1a, fn1a
-       IF ( paero(b)%numc < nclim )  CYCLE
+    DO  ib = start_subrange_1a, end_subrange_1a
+       IF ( paero(ib)%numc < nclim )  CYCLE
        zminusterm   = 0.0_wp
        zplusterm(:) = 0.0_wp
-!       
+!
 !--    Particles lost by coagulation with larger aerosols
-       DO  ll = b+1, fn2b
-          zminusterm = zminusterm + zcc(b,ll) * paero(ll)%numc
+       DO  ll = ib+1, end_subrange_2b
+          zminusterm = zminusterm + zcc(ib,ll) * paero(ll)%numc
        ENDDO
-!       
+!
 !--    Coagulation gain in a bin: change in volume conc. (cm3/cm3):
-       DO ll = in1a, b-1
-          zplusterm(1:2) = zplusterm(1:2) + zcc(ll,b) * paero(ll)%volc(1:2)
-          zplusterm(6:7) = zplusterm(6:7) + zcc(ll,b) * paero(ll)%volc(6:7)
-          zplusterm(8)   = zplusterm(8)   + zcc(ll,b) * paero(ll)%volc(8)
+       DO ll = start_subrange_1a, ib - 1
+          zplusterm(1:2) = zplusterm(1:2) + zcc(ll,ib) * paero(ll)%volc(1:2)
+          zplusterm(6:7) = zplusterm(6:7) + zcc(ll,ib) * paero(ll)%volc(6:7)
+          zplusterm(8)   = zplusterm(8)   + zcc(ll,ib) * paero(ll)%volc(8)
        ENDDO
-!       
+!
 !--    Volume and number concentrations after coagulation update [fxm]
-       paero(b)%volc(1:2) = ( paero(b)%volc(1:2) + ptstep * zplusterm(1:2) * &
-                             paero(b)%numc ) / ( 1.0_wp + ptstep * zminusterm )
-       paero(b)%volc(6:7) = ( paero(b)%volc(6:7) + ptstep * zplusterm(6:7) * &
-                             paero(b)%numc ) / ( 1.0_wp + ptstep * zminusterm )
-       paero(b)%volc(8)   = ( paero(b)%volc(8)   + ptstep * zplusterm(8) *   &
-                             paero(b)%numc ) / ( 1.0_wp + ptstep * zminusterm )
-       paero(b)%numc = paero(b)%numc / ( 1.0_wp + ptstep * zminusterm  +     &
-                        0.5_wp * ptstep * zcc(b,b) * paero(b)%numc )               
+       paero(ib)%volc(1:2) = ( paero(ib)%volc(1:2) + ptstep * zplusterm(1:2) * paero(ib)%numc ) /  &
+                            ( 1.0_wp + ptstep * zminusterm )
+       paero(ib)%volc(6:8) = ( paero(ib)%volc(6:8) + ptstep * zplusterm(6:8) * paero(ib)%numc ) /  &
+                            ( 1.0_wp + ptstep * zminusterm )
+       paero(ib)%numc = paero(ib)%numc / ( 1.0_wp + ptstep * zminusterm + 0.5_wp * ptstep *        &
+                        zcc(ib,ib) * paero(ib)%numc )
     ENDDO
-!             
+!
 !-- Aerosols in subrange 2a:
-    DO  b = in2a, fn2a
-       IF ( paero(b)%numc < nclim )  CYCLE
+    DO  ib = start_subrange_2a, end_subrange_2a
+       IF ( paero(ib)%numc < nclim )  CYCLE
        zminusterm   = 0.0_wp
        zplusterm(:) = 0.0_wp
-!       
+!
 !--    Find corresponding size bin in subrange 2b
-       index_2b = b - in2a + in2b
-!       
+       index_2b = ib - start_subrange_2a + start_subrange_2b
+!
 !--    Particles lost by larger particles in 2a
-       DO  ll = b+1, fn2a
-          zminusterm = zminusterm + zcc(b,ll) * paero(ll)%numc 
+       DO  ll = ib+1, end_subrange_2a
+          zminusterm = zminusterm + zcc(ib,ll) * paero(ll)%numc
        ENDDO
-!       
+!
 !--    Particles lost by larger particles in 2b
        IF ( .NOT. no_insoluble )  THEN
-          DO  ll = index_2b+1, fn2b
-             zminusterm = zminusterm + zcc(b,ll) * paero(ll)%numc
+          DO  ll = index_2b+1, end_subrange_2b
+             zminusterm = zminusterm + zcc(ib,ll) * paero(ll)%numc
           ENDDO
        ENDIF
-!       
+!
 !--    Particle volume gained from smaller particles in subranges 1, 2a and 2b
-       DO  ll = in1a, b-1
-          zplusterm(1:2) = zplusterm(1:2) + zcc(ll,b) * paero(ll)%volc(1:2)
-          zplusterm(6:7) = zplusterm(6:7) + zcc(ll,b) * paero(ll)%volc(6:7)
-          zplusterm(8)   = zplusterm(8)   + zcc(ll,b) * paero(ll)%volc(8)
-       ENDDO  
-!       
+       DO  ll = start_subrange_1a, ib-1
+          zplusterm(1:2) = zplusterm(1:2) + zcc(ll,ib) * paero(ll)%volc(1:2)
+          zplusterm(6:8) = zplusterm(6:8) + zcc(ll,ib) * paero(ll)%volc(6:8)
+       ENDDO
+!
 !--    Particle volume gained from smaller particles in 2a
 !--    (Note, for components not included in the previous loop!)
-       DO  ll = in2a, b-1
-          zplusterm(3:5) = zplusterm(3:5) + zcc(ll,b)*paero(ll)%volc(3:5)             
+       DO  ll = start_subrange_2a, ib-1
+          zplusterm(3:5) = zplusterm(3:5) + zcc(ll,ib)*paero(ll)%volc(3:5)
        ENDDO
-       
-!       
+!
 !--    Particle volume gained from smaller (and equal) particles in 2b
        IF ( .NOT. no_insoluble )  THEN
-          DO  ll = in2b, index_2b
-             zplusterm(1:8) = zplusterm(1:8) + zcc(ll,b) * paero(ll)%volc(1:8)
+          DO  ll = start_subrange_2b, index_2b
+             zplusterm(1:8) = zplusterm(1:8) + zcc(ll,ib) * paero(ll)%volc(1:8)
           ENDDO
        ENDIF
-!       
+!
 !--    Volume and number concentrations after coagulation update [fxm]
-       paero(b)%volc(1:8) = ( paero(b)%volc(1:8) + ptstep * zplusterm(1:8) * &
-                             paero(b)%numc ) / ( 1.0_wp + ptstep * zminusterm )
-       paero(b)%numc = paero(b)%numc / ( 1.0_wp + ptstep * zminusterm +      &
-                        0.5_wp * ptstep * zcc(b,b) * paero(b)%numc )
+       paero(ib)%volc(1:8) = ( paero(ib)%volc(1:8) + ptstep * zplusterm(1:8) * paero(ib)%numc ) /  &
+                            ( 1.0_wp + ptstep * zminusterm )
+       paero(ib)%numc = paero(ib)%numc / ( 1.0_wp + ptstep * zminusterm + 0.5_wp * ptstep *        &
+                        zcc(ib,ib) * paero(ib)%numc )
     ENDDO
-!             
+!
 !-- Aerosols in subrange 2b:
     IF ( .NOT. no_insoluble )  THEN
-       DO  b = in2b, fn2b
-          IF ( paero(b)%numc < nclim )  CYCLE
+       DO  ib = start_subrange_2b, end_subrange_2b
+          IF ( paero(ib)%numc < nclim )  CYCLE
           zminusterm   = 0.0_wp
           zplusterm(:) = 0.0_wp
-!       
+!
 !--       Find corresponding size bin in subsubrange 2a
-          index_2a = b - in2b + in2a
-!       
+          index_2a = ib - start_subrange_2b + start_subrange_2a
+!
 !--       Particles lost to larger particles in subranges 2b
-          DO  ll = b+1, fn2b
-             zminusterm = zminusterm + zcc(b,ll) * paero(ll)%numc
+          DO  ll = ib + 1, end_subrange_2b
+             zminusterm = zminusterm + zcc(ib,ll) * paero(ll)%numc
           ENDDO
-!       
+!
 !--       Particles lost to larger and equal particles in 2a
-          DO  ll = index_2a, fn2a
-             zminusterm = zminusterm + zcc(b,ll) * paero(ll)%numc
+          DO  ll = index_2a, end_subrange_2a
+             zminusterm = zminusterm + zcc(ib,ll) * paero(ll)%numc
           ENDDO
-!       
+!
 !--       Particle volume gained from smaller particles in subranges 1 & 2a
-          DO  ll = in1a, index_2a-1
-             zplusterm(1:8) = zplusterm(1:8) + zcc(ll,b) * paero(ll)%volc(1:8)
+          DO  ll = start_subrange_1a, index_2a - 1
+             zplusterm(1:8) = zplusterm(1:8) + zcc(ll,ib) * paero(ll)%volc(1:8)
           ENDDO
-!       
+!
 !--       Particle volume gained from smaller particles in 2b
-          DO  ll = in2b, b-1
-             zplusterm(1:8) = zplusterm(1:8) + zcc(ll,b) * paero(ll)%volc(1:8)
+          DO  ll = start_subrange_2b, ib - 1
+             zplusterm(1:8) = zplusterm(1:8) + zcc(ll,ib) * paero(ll)%volc(1:8)
           ENDDO
-!       
+!
 !--       Volume and number concentrations after coagulation update [fxm]
-          paero(b)%volc(1:8) = ( paero(b)%volc(1:8) + ptstep * zplusterm(1:8)&
-                           * paero(b)%numc ) / ( 1.0_wp + ptstep * zminusterm )
-          paero(b)%numc = paero(b)%numc / ( 1.0_wp + ptstep * zminusterm  +  &
-                           0.5_wp * ptstep * zcc(b,b) * paero(b)%numc )
+          paero(ib)%volc(1:8) = ( paero(ib)%volc(1:8) + ptstep * zplusterm(1:8) * paero(ib)%numc ) &
+                                / ( 1.0_wp + ptstep * zminusterm )
+          paero(ib)%numc = paero(ib)%numc / ( 1.0_wp + ptstep * zminusterm + 0.5_wp * ptstep *     &
+                           zcc(ib,ib) * paero(ib)%numc )
        ENDDO
     ENDIF
@@ -3682,38 +3891,35 @@
 ! Description:
 ! ------------
-!> Calculation of coagulation coefficients. Extended version of the function 
-!> originally found in mo_salsa_init. 
-!
-!> J. Tonttila, FMI, 05/2014 
-!------------------------------------------------------------------------------! 
+!> Calculation of coagulation coefficients. Extended version of the function
+!> originally found in mo_salsa_init.
+!
+!> J. Tonttila, FMI, 05/2014
+!------------------------------------------------------------------------------!
  REAL(wp) FUNCTION coagc( diam1, diam2, mass1, mass2, temp, pres )
- 
+
     IMPLICIT NONE
-!       
-!-- Input and output variables
-    REAL(wp), INTENT(in) ::  diam1 !< diameter of colliding particle 1 (m)
-    REAL(wp), INTENT(in) ::  diam2 !< diameter of colliding particle 2 (m)
-    REAL(wp), INTENT(in) ::  mass1 !< mass of colliding particle 1 (kg)
-    REAL(wp), INTENT(in) ::  mass2 !< mass of colliding particle 2 (kg)
-    REAL(wp), INTENT(in) ::  pres  !< ambient pressure (Pa?) [fxm]
-    REAL(wp), INTENT(in) ::  temp  !< ambient temperature (K)       
-!
-!-- Local variables
-    REAL(wp) ::  fmdist !< distance of flux matching (m)   
-    REAL(wp) ::  knud_p !< particle Knudsen number
-    REAL(wp) ::  mdiam  !< mean diameter of colliding particles (m)  
-    REAL(wp) ::  mfp    !< mean free path of air molecules (m)    
-    REAL(wp) ::  visc   !< viscosity of air (kg/(m s))                   
-    REAL(wp), DIMENSION (2) ::  beta   !< Cunningham correction factor
-    REAL(wp), DIMENSION (2) ::  dfpart !< particle diffusion coefficient 
-                                       !< (m2/s)       
-    REAL(wp), DIMENSION (2) ::  diam   !< diameters of particles (m)
-    REAL(wp), DIMENSION (2) ::  flux   !< flux in continuum and free molec. 
-                                       !< regime (m/s)       
-    REAL(wp), DIMENSION (2) ::  knud   !< particle Knudsen number        
-    REAL(wp), DIMENSION (2) ::  mpart  !< masses of particles (kg)
-    REAL(wp), DIMENSION (2) ::  mtvel  !< particle mean thermal velocity (m/s)
-    REAL(wp), DIMENSION (2) ::  omega  !< particle mean free path             
-    REAL(wp), DIMENSION (2) ::  tva    !< temporary variable (m)       
+
+    REAL(wp) ::  fmdist  !< distance of flux matching (m)
+    REAL(wp) ::  knud_p  !< particle Knudsen number
+    REAL(wp) ::  mdiam   !< mean diameter of colliding particles (m)
+    REAL(wp) ::  mfp     !< mean free path of air molecules (m)
+    REAL(wp) ::  visc    !< viscosity of air (kg/(m s))
+
+    REAL(wp), INTENT(in) ::  diam1  !< diameter of colliding particle 1 (m)
+    REAL(wp), INTENT(in) ::  diam2  !< diameter of colliding particle 2 (m)
+    REAL(wp), INTENT(in) ::  mass1  !< mass of colliding particle 1 (kg)
+    REAL(wp), INTENT(in) ::  mass2  !< mass of colliding particle 2 (kg)
+    REAL(wp), INTENT(in) ::  pres   !< ambient pressure (Pa?) [fxm]
+    REAL(wp), INTENT(in) ::  temp   !< ambient temperature (K)
+
+    REAL(wp), DIMENSION (2) ::  beta    !< Cunningham correction factor
+    REAL(wp), DIMENSION (2) ::  dfpart  !< particle diffusion coefficient (m2/s)
+    REAL(wp), DIMENSION (2) ::  diam    !< diameters of particles (m)
+    REAL(wp), DIMENSION (2) ::  flux    !< flux in continuum and free molec. regime (m/s)
+    REAL(wp), DIMENSION (2) ::  knud    !< particle Knudsen number
+    REAL(wp), DIMENSION (2) ::  mpart   !< masses of particles (kg)
+    REAL(wp), DIMENSION (2) ::  mtvel   !< particle mean thermal velocity (m/s)
+    REAL(wp), DIMENSION (2) ::  omega   !< particle mean free path
+    REAL(wp), DIMENSION (2) ::  tva     !< temporary variable (m)
 !
 !-- Initialisation
@@ -3723,53 +3929,56 @@
     diam  = (/ diam1, diam2 /) !< particle diameters (m)
     mpart = (/ mass1, mass2 /) !< particle masses (kg)
-!-- Viscosity of air (kg/(m s))       
-    visc = ( 7.44523E-3_wp * temp ** 1.5_wp ) /                                &
-           ( 5093.0_wp * ( temp + 110.4_wp ) ) 
-!-- Mean free path of air (m)            
+!
+!-- Viscosity of air (kg/(m s))
+    visc = ( 7.44523E-3_wp * temp ** 1.5_wp ) / ( 5093.0_wp * ( temp + 110.4_wp ) )
+!
+!-- Mean free path of air (m)
     mfp = ( 1.656E-10_wp * temp + 1.828E-8_wp ) * ( p_0 + 1325.0_wp ) / pres
 !
 !-- 2) Slip correction factor for small particles 
     knud = 2.0_wp * EXP( LOG(mfp) - LOG(diam) )! Knudsen number for air (15.23)
-!-- Cunningham correction factor (Allen and Raabe, Aerosol Sci. Tech. 4, 269)       
+!
+!-- Cunningham correction factor (Allen and Raabe, Aerosol Sci. Tech. 4, 269)
     beta = 1.0_wp + knud * ( 1.142_wp + 0.558_wp * EXP( -0.999_wp / knud ) )
 !
 !-- 3) Particle properties
 !-- Diffusion coefficient (m2/s) (Jacobson (2005) eq. 15.29)
-    dfpart = beta * abo * temp / ( 3.0_wp * pi * visc * diam ) 
+    dfpart = beta * abo * temp / ( 3.0_wp * pi * visc * diam )
+!
 !-- Mean thermal velocity (m/s) (Jacobson (2005) eq. 15.32)
     mtvel = SQRT( ( 8.0_wp * abo * temp ) / ( pi * mpart ) )
+!
 !-- Particle mean free path (m) (Jacobson (2005) eq. 15.34 )
-    omega = 8.0_wp * dfpart / ( pi * mtvel ) 
+    omega = 8.0_wp * dfpart / ( pi * mtvel )
+!
 !-- Mean diameter (m)
     mdiam = 0.5_wp * ( diam(1) + diam(2) )
 !
-!-- 4) Calculation of fluxes (Brownian collision kernels) and flux matching 
+!-- 4) Calculation of fluxes (Brownian collision kernels) and flux matching
 !-- following Jacobson (2005):
+!
 !-- Flux in continuum regime (m3/s) (eq. 15.28)
     flux(1) = 4.0_wp * pi * mdiam * ( dfpart(1) + dfpart(2) )
+!
 !-- Flux in free molec. regime (m3/s) (eq. 15.31)
-    flux(2) = pi * SQRT( ( mtvel(1)**2.0_wp ) + ( mtvel(2)**2.0_wp ) ) *      &
-              ( mdiam**2.0_wp )
+    flux(2) = pi * SQRT( ( mtvel(1)**2 ) + ( mtvel(2)**2 ) ) * ( mdiam**2 )
+!
 !-- temporary variables (m) to calculate flux matching distance (m)
-    tva(1) = ( ( mdiam + omega(1) )**3.0_wp - ( mdiam**2.0_wp +                &
-               omega(1)**2.0_wp ) * SQRT( ( mdiam**2.0_wp + omega(1)**2.0_wp ) &
-               ) ) / ( 3.0_wp * mdiam * omega(1) ) - mdiam
-    tva(2) = ( ( mdiam + omega(2) )**3.0_wp - ( mdiam**2.0_wp +                &
-               omega(2)**2.0_wp ) * SQRT( ( mdiam**2 + omega(2)**2 ) ) ) /     &
-             ( 3.0_wp * mdiam * omega(2) ) - mdiam
-!-- Flux matching distance (m) i.e. the mean distance from the centre of a 
-!-- sphere reached by particles leaving sphere's surface and travelling a 
-!-- distance of particle mean free path mfp (eq. 15 34)                 
-    fmdist = SQRT( tva(1)**2 + tva(2)**2.0_wp) 
-!
-!-- 5) Coagulation coefficient (m3/s) (eq. 15.33). Here assumed 
-!-- coalescence efficiency 1!!
-    coagc = flux(1) / ( mdiam / ( mdiam + fmdist) + flux(1) / flux(2) ) 
-!-- coagulation coefficient = coalescence efficiency * collision kernel
-!
-!-- Corrected collision kernel following Karl et al., 2016 (ACP):
-!-- Inclusion of van der Waals and viscous forces
+    tva(1) = ( ( mdiam + omega(1) )**3 - ( mdiam**2 + omega(1)**2 ) * SQRT( ( mdiam**2 +           &
+               omega(1)**2 ) ) ) / ( 3.0_wp * mdiam * omega(1) ) - mdiam
+    tva(2) = ( ( mdiam + omega(2) )**3 - ( mdiam**2 + omega(2)**2 ) * SQRT( ( mdiam**2 +           &
+               omega(2)**2 ) ) ) / ( 3.0_wp * mdiam * omega(2) ) - mdiam
+!
+!-- Flux matching distance (m): the mean distance from the centre of a sphere reached by particles
+!-- that leave sphere's surface and travel a distance of particle mean free path (eq. 15.34)
+    fmdist = SQRT( tva(1)**2 + tva(2)**2 )
+!
+!-- 5) Coagulation coefficient = coalescence efficiency * collision kernel (m3/s) (eq. 15.33). 
+!--    Here assumed coalescence efficiency 1!!
+    coagc = flux(1) / ( mdiam / ( mdiam + fmdist) + flux(1) / flux(2) )
+!
+!-- Corrected collision kernel (Karl et al., 2016 (ACP)): Include van der Waals and viscous forces
     IF ( van_der_waals_coagc )  THEN
-       knud_p = SQRT( omega(1)**2 + omega(2)**2 ) / mdiam   
+       knud_p = SQRT( omega(1)**2 + omega(2)**2 ) / mdiam
        IF ( knud_p >= 0.1_wp  .AND.  knud_p <= 10.0_wp )  THEN
           coagc = coagc * ( 2.0_wp + 0.4_wp * LOG( knud_p ) )
@@ -3778,8 +3987,8 @@
        ENDIF
     ENDIF
-    
+
  END FUNCTION coagc
- 
-!------------------------------------------------------------------------------!    
+
+!------------------------------------------------------------------------------!
 ! Description:
 ! ------------
@@ -3799,80 +4008,73 @@
 !> D = {1.d-7*sqrt(1/M_air + 1/M_gas)*T^1.75} / &
 !      {p_atm/p_stand * (d_air^(1/3) + d_gas^(1/3))^2 }
-! M_air = 28.965 : molar mass of air (g/mol)
-! d_air = 19.70  : diffusion volume of air
-! M_h2so4 = 98.08 : molar mass of h2so4 (g/mol)
-! d_h2so4 = 51.96  : diffusion volume of h2so4 
+!> M_air = 28.965 : molar mass of air (g/mol)
+!> d_air = 19.70  : diffusion volume of air
+!> M_h2so4 = 98.08 : molar mass of h2so4 (g/mol)
+!> d_h2so4 = 51.96  : diffusion volume of h2so4 
 !
 !> Called from main aerosol model
-!
-!> fxm: calculated for empty bins too
-!> fxm: same diffusion coefficients and mean free paths used for sulphuric acid
-!>      and organic vapours (average values? 'real' values for each?)
-!> fxm: one should really couple with vapour production and loss terms as well
-!>      should nucleation be coupled here as well????
-!
-! Coded by:
-! Hannele Korhonen (FMI) 2005
-! Harri Kokkola (FMI) 2006
-! Juha Tonttila (FMI) 2014
-! Rewritten to PALM by Mona Kurppa (UHel) 2017
-!------------------------------------------------------------------------------!
- SUBROUTINE condensation( paero, pcsa, pcocnv, pcocsv, pchno3, pcnh3, pcw, pcs,&
-                          ptemp, ppres, ptstep, prtcl )
-        
+!> For equations, see Jacobson, Fundamentals of Atmospheric Modeling, 2nd Edition (2005)
+!
+!> Coded by:
+!> Hannele Korhonen (FMI) 2005
+!> Harri Kokkola (FMI) 2006
+!> Juha Tonttila (FMI) 2014
+!> Rewritten to PALM by Mona Kurppa (UHel) 2017
+!------------------------------------------------------------------------------!
+ SUBROUTINE condensation( paero, pc_sa, pc_ocnv, pcocsv, pchno3, pc_nh3, pcw, pcs, ptemp, ppres,   &
+                          ptstep, prtcl )
+
     IMPLICIT NONE
-    
-!-- Input and output variables
-    REAL(wp), INTENT(IN) ::  ppres !< ambient pressure (Pa)
-    REAL(wp), INTENT(IN) ::  pcs   !< Water vapour saturation concentration 
-                                   !< (kg/m3)      
-    REAL(wp), INTENT(IN) ::  ptemp !< ambient temperature (K)
-    REAL(wp), INTENT(IN) ::  ptstep            !< timestep (s)  
-    TYPE(component_index), INTENT(in) :: prtcl !< Keeps track which substances
-                                               !< are used                                               
-    REAL(wp), INTENT(INOUT) ::  pchno3 !< Gas concentrations (#/m3):
-                                       !< nitric acid HNO3
-    REAL(wp), INTENT(INOUT) ::  pcnh3  !< ammonia NH3
-    REAL(wp), INTENT(INOUT) ::  pcocnv !< non-volatile organics
-    REAL(wp), INTENT(INOUT) ::  pcocsv !< semi-volatile organics
-    REAL(wp), INTENT(INOUT) ::  pcsa   !< sulphuric acid H2SO4
-    REAL(wp), INTENT(INOUT) ::  pcw    !< Water vapor concentration (kg/m3) 
-    TYPE(t_section), INTENT(inout) ::  paero(fn2b) !< Aerosol properties                                      
-!-- Local variables 
-    REAL(wp) ::  zbeta(fn2b) !< transitional correction factor for aerosols
-    REAL(wp) ::  zcolrate(fn2b) !< collision rate of molecules to particles 
-                                !< (1/s)
-    REAL(wp) ::  zcolrate_ocnv(fn2b) !< collision rate of organic molecules 
-                                     !< to particles (1/s)
-    REAL(wp) ::  zcs_ocnv !< condensation sink of nonvolatile organics (1/s)       
-    REAL(wp) ::  zcs_ocsv !< condensation sink of semivolatile organics (1/s)
-    REAL(wp) ::  zcs_su !< condensation sink of sulfate (1/s)
-    REAL(wp) ::  zcs_tot!< total condensation sink (1/s) (gases) 
-!-- vapour concentration after time step (#/m3)
-    REAL(wp) ::  zcvap_new1 !< sulphuric acid
-    REAL(wp) ::  zcvap_new2 !< nonvolatile organics
-    REAL(wp) ::  zcvap_new3 !< semivolatile organics
-    REAL(wp) ::  zdfpart(in1a+1) !< particle diffusion coefficient (m2/s)     
-    REAL(wp) ::  zdfvap !< air diffusion coefficient (m2/s)
-!-- change in vapour concentration (#/m3)
-    REAL(wp) ::  zdvap1 !< sulphuric acid
-    REAL(wp) ::  zdvap2 !< nonvolatile organics
-    REAL(wp) ::  zdvap3 !< semivolatile organics 
-    REAL(wp) ::  zdvoloc(fn2b) !< change of organics volume in each bin [fxm]    
-    REAL(wp) ::  zdvolsa(fn2b) !< change of sulphate volume in each bin [fxm]
-    REAL(wp) ::  zj3n3(2)      !< Formation massrate of molecules in 
-                               !< nucleation, (molec/m3s). 1: H2SO4
-                               !< and 2: organic vapor       
-    REAL(wp) ::  zknud(fn2b) !< particle Knudsen number       
-    REAL(wp) ::  zmfp    !< mean free path of condensing vapour (m)
-    REAL(wp) ::  zrh     !< Relative humidity [0-1]         
-    REAL(wp) ::  zvisc   !< viscosity of air (kg/(m s))     
-    REAL(wp) ::  zn_vs_c !< ratio of nucleation of all mass transfer in the 
-                         !< smallest bin
-    REAL(wp) ::  zxocnv  !< ratio of organic vapour in 3nm particles 
-    REAL(wp) ::  zxsa    !< Ratio in 3nm particles: sulphuric acid
-    
+
+    INTEGER(iwp) ::  ss      !< start index
+    INTEGER(iwp) ::  ee      !< end index
+
+    REAL(wp) ::  zcs_ocnv    !< condensation sink of nonvolatile organics (1/s)
+    REAL(wp) ::  zcs_ocsv    !< condensation sink of semivolatile organics (1/s)
+    REAL(wp) ::  zcs_su      !< condensation sink of sulfate (1/s)
+    REAL(wp) ::  zcs_tot     !< total condensation sink (1/s) (gases)
+    REAL(wp) ::  zcvap_new1  !< vapour concentration after time step (#/m3): sulphuric acid
+    REAL(wp) ::  zcvap_new2  !< nonvolatile organics
+    REAL(wp) ::  zcvap_new3  !< semivolatile organics
+    REAL(wp) ::  zdfvap      !< air diffusion coefficient (m2/s)
+    REAL(wp) ::  zdvap1      !< change in vapour concentration (#/m3): sulphuric acid
+    REAL(wp) ::  zdvap2      !< nonvolatile organics
+    REAL(wp) ::  zdvap3      !< semivolatile organics
+    REAL(wp) ::  zmfp        !< mean free path of condensing vapour (m)
+    REAL(wp) ::  zrh         !< Relative humidity [0-1]
+    REAL(wp) ::  zvisc       !< viscosity of air (kg/(m s))
+    REAL(wp) ::  zn_vs_c     !< ratio of nucleation of all mass transfer in the smallest bin
+    REAL(wp) ::  zxocnv      !< ratio of organic vapour in 3nm particles
+    REAL(wp) ::  zxsa        !< Ratio in 3nm particles: sulphuric acid
+
+    REAL(wp), INTENT(in) ::  ppres   !< ambient pressure (Pa)
+    REAL(wp), INTENT(in) ::  pcs     !< Water vapour saturation concentration (kg/m3)
+    REAL(wp), INTENT(in) ::  ptemp   !< ambient temperature (K)
+    REAL(wp), INTENT(in) ::  ptstep  !< timestep (s)
+
+    REAL(wp), INTENT(inout) ::  pchno3   !< Gas concentrations (#/m3): nitric acid HNO3
+    REAL(wp), INTENT(inout) ::  pc_nh3   !< ammonia NH3
+    REAL(wp), INTENT(inout) ::  pc_ocnv  !< non-volatile organics
+    REAL(wp), INTENT(inout) ::  pcocsv   !< semi-volatile organics
+    REAL(wp), INTENT(inout) ::  pc_sa    !< sulphuric acid H2SO4
+    REAL(wp), INTENT(inout) ::  pcw      !< Water vapor concentration (kg/m3)
+
+    REAL(wp), DIMENSION(nbins_aerosol)               ::  zbeta          !< transitional correction factor
+    REAL(wp), DIMENSION(nbins_aerosol)               ::  zcolrate       !< collision rate (1/s)
+    REAL(wp), DIMENSION(nbins_aerosol)               ::  zcolrate_ocnv  !< collision rate of non-vol. OC (1/s)
+    REAL(wp), DIMENSION(start_subrange_1a+1) ::  zdfpart        !< particle diffusion coefficient (m2/s)
+    REAL(wp), DIMENSION(nbins_aerosol)               ::  zdvoloc        !< change of organics volume
+    REAL(wp), DIMENSION(nbins_aerosol)               ::  zdvolsa        !< change of sulphate volume
+    REAL(wp), DIMENSION(2)                   ::  zj3n3          !< Formation massrate of molecules
+                                                                !< in nucleation, (molec/m3s),
+                                                                !< 1: H2SO4 and 2: organic vapor
+    REAL(wp), DIMENSION(nbins_aerosol)   ::  zknud          !< particle Knudsen number
+
+    TYPE(component_index), INTENT(in) :: prtcl  !< Keeps track which substances are used
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero  !< Aerosol properties
+
     zj3n3  = 0.0_wp
-    zrh    = pcw / pcs    
+    zrh    = pcw / pcs
     zxocnv = 0.0_wp
     zxsa   = 0.0_wp
@@ -3880,6 +4082,6 @@
 !-- Nucleation
     IF ( nsnucl > 0 )  THEN
-       CALL nucleation( paero, ptemp, zrh, ppres, pcsa, pcocnv, pcnh3, ptstep, &
-                        zj3n3, zxsa, zxocnv )
+       CALL nucleation( paero, ptemp, zrh, ppres, pc_sa, pc_ocnv, pc_nh3, ptstep, zj3n3, zxsa,     &
+                        zxocnv )
     ENDIF
 !
@@ -3888,51 +4090,52 @@
 !
 !--    Initialise:
-       zdvolsa = 0.0_wp  
+       zdvolsa = 0.0_wp
        zdvoloc = 0.0_wp
        zcolrate = 0.0_wp
-!             
+!
 !--    1) Properties of air and condensing gases:
 !--    Viscosity of air (kg/(m s)) (Eq. 4.54 in Jabonson (2005))
-       zvisc = ( 7.44523E-3_wp * ptemp ** 1.5_wp ) / ( 5093.0_wp *             &
-                 ( ptemp + 110.4_wp ) )
+       zvisc = ( 7.44523E-3_wp * ptemp ** 1.5_wp ) / ( 5093.0_wp * ( ptemp + 110.4_wp ) )
+!
 !--    Diffusion coefficient of air (m2/s)
-       zdfvap = 5.1111E-10_wp * ptemp ** 1.75_wp * ( p_0 + 1325.0_wp ) / ppres 
+       zdfvap = 5.1111E-10_wp * ptemp ** 1.75_wp * ( p_0 + 1325.0_wp ) / ppres
+!
 !--    Mean free path (m): same for H2SO4 and organic compounds
        zmfp = 3.0_wp * zdfvap * SQRT( pi * amh2so4 / ( 8.0_wp * argas * ptemp ) )
-!                    
-!--    2) Transition regime correction factor zbeta for particles:
-!--       Fuchs and Sutugin (1971), In: Hidy et al. (ed.) Topics in current 
-!--       aerosol research, Pergamon. Size of condensing molecule considered  
-!--       only for nucleation mode (3 - 20 nm)
-!
-!--    Particle Knudsen number: condensation of gases on aerosols 
-       zknud(in1a:in1a+1) = 2.0_wp * zmfp / ( paero(in1a:in1a+1)%dwet + d_sa )
-       zknud(in1a+2:fn2b) = 2.0_wp * zmfp / paero(in1a+2:fn2b)%dwet
-!    
-!--    Transitional correction factor: aerosol + gas (the semi-empirical Fuchs-
-!--    Sutugin interpolation function (Fuchs and Sutugin, 1971))
-       zbeta = ( zknud + 1.0_wp ) / ( 0.377_wp * zknud + 1.0_wp + 4.0_wp /     &
-               ( 3.0_wp * massacc ) * ( zknud + zknud ** 2.0_wp ) )
-!                   
+!
+!--    2) Transition regime correction factor zbeta for particles (Fuchs and Sutugin (1971)):
+!--       Size of condensing molecule considered only for nucleation mode (3 - 20 nm).
+!
+!--    Particle Knudsen number: condensation of gases on aerosols
+       ss = start_subrange_1a
+       ee = start_subrange_1a+1
+       zknud(ss:ee) = 2.0_wp * zmfp / ( paero(ss:ee)%dwet + d_sa )
+       ss = start_subrange_1a+2
+       ee = end_subrange_2b
+       zknud(ss:ee) = 2.0_wp * zmfp / paero(ss:ee)%dwet
+!
+!--    Transitional correction factor: aerosol + gas (the semi-empirical Fuchs- Sutugin 
+!--    interpolation function (Fuchs and Sutugin, 1971))
+       zbeta = ( zknud + 1.0_wp ) / ( 0.377_wp * zknud + 1.0_wp + 4.0_wp / ( 3.0_wp * massacc ) *  &
+               ( zknud + zknud ** 2 ) )
+!
 !--    3) Collision rate of molecules to particles
-!--       Particle diffusion coefficient considered only for nucleation mode 
-!--       (3 - 20 nm)
+!--       Particle diffusion coefficient considered only for nucleation mode (3 - 20 nm)
 !
 !--    Particle diffusion coefficient (m2/s) (e.g. Eq. 15.29 in Jacobson (2005))
-       zdfpart = abo * ptemp * zbeta(in1a:in1a+1) / ( 3.0_wp * pi * zvisc *    &
-                 paero(in1a:in1a+1)%dwet )
-!              
-!--    Collision rate (mass-transfer coefficient): gases on aerosols (1/s) 
-!--    (Eq. 16.64 in Jacobson (2005))
-       zcolrate(in1a:in1a+1) = MERGE( 2.0_wp * pi *                            &
-                                      ( paero(in1a:in1a+1)%dwet + d_sa ) *     &
-                                      ( zdfvap + zdfpart ) * zbeta(in1a:in1a+1)& 
-                                        * paero(in1a:in1a+1)%numc, 0.0_wp,     &
-                                      paero(in1a:in1a+1)%numc > nclim )
-       zcolrate(in1a+2:fn2b) = MERGE( 2.0_wp * pi * paero(in1a+2:fn2b)%dwet *  &
-                                      zdfvap * zbeta(in1a+2:fn2b) *            &
-                                      paero(in1a+2:fn2b)%numc, 0.0_wp,         &
-                                      paero(in1a+2:fn2b)%numc > nclim )
-!                  
+       zdfpart = abo * ptemp * zbeta(start_subrange_1a:start_subrange_1a+1) / ( 3.0_wp * pi * zvisc&
+                 * paero(start_subrange_1a:start_subrange_1a+1)%dwet)
+!
+!--    Collision rate (mass-transfer coefficient): gases on aerosols (1/s) (Eq. 16.64 in 
+!--    Jacobson (2005))
+       ss = start_subrange_1a
+       ee = start_subrange_1a+1
+       zcolrate(ss:ee) = MERGE( 2.0_wp * pi * ( paero(ss:ee)%dwet + d_sa ) * ( zdfvap + zdfpart ) *&
+                               zbeta(ss:ee) * paero(ss:ee)%numc, 0.0_wp, paero(ss:ee)%numc > nclim )
+       ss = start_subrange_1a+2
+       ee = end_subrange_2b
+       zcolrate(ss:ee) = MERGE( 2.0_wp * pi * paero(ss:ee)%dwet * zdfvap * zbeta(ss:ee) *          &
+                                paero(ss:ee)%numc, 0.0_wp, paero(ss:ee)%numc > nclim )
+!
 !-- 4) Condensation sink (1/s)
        zcs_tot = SUM( zcolrate )   ! total sink
